#include<iostream>
#include<algorithm>
#include<vector>
#include<numeric>

using namespace std;

bool cOpen(int n, const vector<int>& h, vector<int>& order){

    long long tSum = accumulate(h.begin(), h.end(), 0LL);
    double avg = (double)tSum/n;
    vector<bool> opened(n, false);
    long long currSum = 0;
    int opCount = 0;

    for(int i = 0; i < n; ++i){
        int minInd = -1;
        for(int j = 0; j < n; ++j){
            if(!opened[j] && (currSum + h[j])/(double)(opCount + 1) <= avg){
                if(minInd == -1 || h[j] < h[minInd]){
                    minInd = j;
                }
            }
        }

        if(minInd == -1){
            return false;
        }

        opened[minInd] = true;
        order.push_back(minInd + 1);
        currSum += h[minInd];
        opCount++;

    }

    return true;


}


int main(){

    int n;
    cin>>n;

    vector<int> h(n);

    for(int i = 0; i<n; ++i)
    {
        cin>>h[i];
    }

    vector<int> order;


    if(cOpen(n, h, order)){
        for(int x: order){
            cout<< x << " ";
        }
        cout<<endl;
    }else{
        cout<< "impossible"<<endl;

    }


    return 0;
}




