#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>

using namespace std;

// BFS     
void bfs(int start, const vector<vector<int>>& graph, vector<bool>& visited, vector<int>& component) {
    queue<int> q;
    q.push(start);
    visited[start] = true;

    while (!q.empty()) {
        int node = q.front();
        q.pop();
        component.push_back(node);

        for (int neighbor : graph[node]) {
            if (!visited[neighbor]) {
                visited[neighbor] = true;
                q.push(neighbor);
            }
        }
    }
}

int findMinimumNewEdges(int n, const vector<pair<int, int>>& edges) {
    //  
    vector<vector<int>> graph(n + 1);
    for (const auto& [u, v] : edges) {
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    //    
    vector<bool> visited(n + 1, false);
    vector<vector<int>> components;

    for (int i = 1; i <= n; ++i) {
        if (!visited[i]) {
            vector<int> component;
            bfs(i, graph, visited, component);
            components.push_back(component);
        }
    }

    //         - 1
    return components.size() - 1;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        edges[i] = {u, v};
    }

    int result = findMinimumNewEdges(n, edges);
    cout << result << endl;

    return 0;
}
