#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 2e5+ 5;
vector <int> graph[MAXN];

int dist[MAXN];
int distToNode[MAXN];

void BFS(int node)
{
    queue <int> q;
    q.push(node);

    while (!q.empty())
    {
        int currNode = q.front();
        q.pop();

        for (int newNode:graph[currNode])
        {
            if (dist[newNode] != -1)
                continue;

            dist[newNode] = dist[currNode]+1;

            if (distToNode[dist[newNode]] == -1)
                distToNode[dist[newNode]] = newNode;

            q.push(newNode);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dist, -1, sizeof(dist));
    memset(distToNode, -1, sizeof(distToNode));

    int N, M;
    cin >> N >> M;

    for (int i = 0; i < M; i++)
    {
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    dist[1] = 0;
    distToNode[0] = 1;
    BFS(1);

    int64_t ans = 0;
    for (int i = 1; i <= N; i++)
    {
        if (dist[i] != -1)
            continue;

        dist[i] = dist[i-1];
        int node = distToNode[dist[i]-1];
        graph[node].push_back(i);
        graph[i].push_back(node);
        ans++;

        //cout << node << "->" << i << " " << dist[i] << endl;
        BFS(i);
    }

    cout << ans << endl;

    return 0;
}
