#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m, q;

vector<vector<int>> land;

int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};

struct point{
    int x, y;
    point(){};
    point(int _x, int _y){
        x = _x;
        y = _y;
    }
};

void read(){
    cin >> n >> m >> q;
    land.resize(n, vector<int>(m, 0));
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if((i&j) == 0){
                land[i][j] = 1;
            }
        }
    }
}

void bfs(int a, int b, int c, int d, vector<vector<int>>& used){
    queue<point> q;

    q.push(point(a, b));
    if(land[a][b] == 1) used[a][b] = 1;

    while(!q.empty()){
        point p = q.front();
        q.pop();

        for(int i = 0; i < 4; i++){
            int newX = p.x + dx[i];
            int newY = p.y + dy[i];
            if(newX >= a && newX <= c && newY >= b && newY <= d && !used[newX][newY] && land[newX][newY]){
                q.push(point(newX, newY));
                used[newX][newY] = 1;
            }
        }

    }
}

int check_island(int a, int b, int c, int d){
    vector<vector<int>> used(n, vector<int>(m, 0));

    int count = 0;

    for(int i = a; i <= c; i++){
        for(int j = b; j <= d; j++){
            if(land[i][j] == 1 && !used[i][j]){
                bfs(i, j, c, d, used);
                count ++;
            }
        }
    }

    return count;
}

int main(){
    read();
    for(int i = 0; i < q; i++){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int res = check_island(x1, y1, x2, y2);
        cout << res << endl;
    }
    return 0;
}