#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m, q;

vector<int> land;

int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};

struct point{
    int x, y;
    point(){};
    point(int _x, int _y){
        x = _x;
        y = _y;
    }
};

void read(){
    cin >> n >> m >> q;
    land.resize(n*m, 0);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if((i&j) == 0){
                land[i*m + j] = 1;
            }
        }
    }
}

void dfs(int a, int b, int c, int d, vector<int>& used){ 
    used[a*d + b] = 1;
  
    for(int i = 0; i < 4; i++){
        int newX = a + dx[i];
        int newY = b + dy[i];
        if(newX >= a && newX <= c && newY >= b && newY <= d && !used[newX*d + newY] && land[newX*d + newY]){
            dfs(newX, newY, c, d, used);
        }
    }

}

int check_island(int a, int b, int c, int d){
    vector<int> used(n *m,  0);

    int count = 0;

    for(int i = a; i <= c; i++){
        for(int j = b; j <= d; j++){
            if(land[i*d + j] == 1 && !used[i * d + j]){
                dfs(i, j, n, m, used);
                count ++;
            }
        }
    }

    return count;
}

int main(){
    read();
    for(int i = 0; i < q; i++){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int res = check_island(x1, y1, x2, y2);
        cout << res << endl;
    }
    return 0;
}