#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl '\n'

struct point {
  int x, y;
  point() {}
  point(int _x, int _y) : x(_x), y(_y) {}
};

const int maxn = 1 + 1e4;
int n, m, q;
vector<vector<bool>> grid;
bool visited[maxn][maxn];
point dir[] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
point limit1, limit2;

void dfs(point p) {
  visited[p.x][p.y] = true;
  for (auto &[dx, dy] : dir) {
    int nx = p.x + dx, ny = p.y + dy;
    if (nx < limit1.x || nx > limit2.x || ny < limit1.y || ny > limit2.y ||
        grid[nx][ny] == true)
      continue;

    if (!visited[nx][ny])
      dfs({nx, ny});
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n >> m >> q;

  grid.resize(n, vector<bool>(m));
  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++)
      grid[i][j] = (i & j);

  while (q--) {
    memset(visited, 0, sizeof(visited));
    point p1, p2;
    cin >> p1.x >> p1.y >> p2.x >> p2.y;
    limit1 = p1, limit2 = p2;

    int cc = 0;
    for (int i = p1.x; i <= p2.x; i++)
      for (int j = p1.y; j <= p2.y; j++) {
        if (!visited[i][j] && grid[i][j] == false) {
          dfs({i, j});
          cc++;
        }
      }

    cout << cc << endl;
  }
}
